Index: palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- palm/trunk/SOURCE/advec_ws.f90	(revision 3633)
+++ palm/trunk/SOURCE/advec_ws.f90	(revision 3634)
@@ -5282,27 +6077,27 @@
 
                 tend(k,j,i) = tend(k,j,i) - (                                 &
-                      ( flux_r(k) + diss_r(k)                                 &
-                    -   swap_flux_x_local_w(k,j) - swap_diss_x_local_w(k,j)   &
-                      ) * ddx                                                 &
-                    + ( flux_n(k) + diss_n(k)                                 &
-                    -   swap_flux_y_local_w(k)   - swap_diss_y_local_w(k)     &
-                      ) * ddy                                                 &
-                    + ( ( flux_t(k) + diss_t(k) )                             &
-                    -   ( flux_d    + diss_d    )                             &
-                      ) * drho_air_zw(k) * ddzu(k+1)                          &
+                      ( ( flux_r + diss_r )                                   &
+                    -   ( flux_l + diss_l ) ) * ddx                           &
+                    + ( ( flux_n + diss_n )                                   &
+                    -   ( flux_s + diss_s ) ) * ddy                           &
+                    + ( ( flux_t + diss_t )                                   &
+                    -   ( flux_d + diss_d ) ) * drho_air_zw(k) * ddzu(k+1)    &
                                             )  + div * w(k,j,i)
 
-                swap_flux_x_local_w(k,j) = flux_r(k)
-                swap_diss_x_local_w(k,j) = diss_r(k)
-                swap_flux_y_local_w(k)   = flux_n(k)
-                swap_diss_y_local_w(k)   = diss_n(k)
-                flux_d                   = flux_t(k)
-                diss_d                   = diss_t(k)
-
+#ifndef _OPENACC
+                swap_flux_x_local_w(k,j) = flux_r
+                swap_diss_x_local_w(k,j) = diss_r
+                swap_flux_y_local_w(k)   = flux_n
+                swap_diss_y_local_w(k)   = diss_n
+#endif
+                flux_d                   = flux_t
+                diss_d                   = diss_t
+
+                !$ACC ATOMIC
                 sums_ws2_ws_l(k,tn)  = sums_ws2_ws_l(k,tn)                    &
-                      + ( flux_t(k)                                           &
+                      + ( flux_t                                              &
                        * ( w_comp - 2.0_wp * hom(k,1,3,0)                   ) &
                        / ( w_comp + SIGN( 1.0E-20_wp, w_comp )              ) &
-                        + diss_t(k)                                           &
+                        + diss_t                                              &
                        *   ABS( w_comp - 2.0_wp * hom(k,1,3,0)              ) &
                        / ( ABS( w_comp ) + 1.0E-20_wp                       ) &
Index: palm/trunk/SOURCE/basic_constants_and_equations_mod.f90
===================================================================
--- palm/trunk/SOURCE/basic_constants_and_equations_mod.f90	(revision 3633)
+++ palm/trunk/SOURCE/basic_constants_and_equations_mod.f90	(revision 3634)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! OpenACC port for SPEC
+! 
+! 3449 2018-10-29 19:36:56Z suehring
 ! +degc_to_k 
 ! 
@@ -58,4 +61,5 @@
     REAL(wp), PARAMETER ::  molecular_weight_of_water = 0.01801528_wp !< mol. m. H2O (kg mol-1)
     REAL(wp), PARAMETER ::  pi = 3.141592654_wp                       !< PI
+    !$ACC DECLARE COPYIN(pi)
     REAL(wp), PARAMETER ::  rho_l = 1.0E3_wp                          !< density of water (kg m-3)
     REAL(wp), PARAMETER ::  rho_nacl = 2165.0_wp                      !< density of NaCl (kg m-3)
Index: palm/trunk/SOURCE/boundary_conds.f90
===================================================================
--- palm/trunk/SOURCE/boundary_conds.f90	(revision 3633)
+++ palm/trunk/SOURCE/boundary_conds.f90	(revision 3634)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! OpenACC port for SPEC
+! 
+! 3589 2018-11-30 15:09:51Z suehring
 ! Move the control parameter "salsa" from salsa_mod to control_parameters 
 ! (M. Kurppa)
@@ -289,4 +292,6 @@
        kb = MERGE( -1, 1, l == 0 )
        !$OMP PARALLEL DO PRIVATE( i, j, k )
+       !$ACC PARALLEL LOOP PRIVATE(i, j, k) &
+       !$ACC PRESENT(bc_h, w_p)
        DO  m = 1, bc_h(l)%ns
           i = bc_h(l)%i(m)            
@@ -300,6 +305,8 @@
 !-- Top boundary. A nested domain ( ibc_uv_t = 3 ) does not require settings.
     IF ( ibc_uv_t == 0 )  THEN
+        !$ACC KERNELS PRESENT(u_p, v_p, u_init, v_init)
         u_p(nzt+1,:,:) = u_init(nzt+1)
         v_p(nzt+1,:,:) = v_init(nzt+1)
+        !$ACC END KERNELS
     ELSEIF ( ibc_uv_t == 1 )  THEN
         u_p(nzt+1,:,:) = u_p(nzt,:,:)
@@ -311,5 +318,7 @@
     IF (  .NOT.  child_domain  .AND.  .NOT.  nesting_offline  .AND.            &
                  TRIM(coupling_mode) /= 'vnested_fine' )  THEN
+       !$ACC KERNELS PRESENT(w_p)
        w_p(nzt:nzt+1,:,:) = 0.0_wp  !< nzt is not a prognostic level (but cf. pres)
+       !$ACC END KERNELS
     ENDIF
 
@@ -342,4 +351,6 @@
           kb = MERGE( -1, 1, l == 0 )
           !$OMP PARALLEL DO PRIVATE( i, j, k )
+          !$ACC PARALLEL LOOP PRIVATE(i, j, k) &
+          !$ACC PRESENT(bc_h, pt_p)
           DO  m = 1, bc_h(l)%ns
              i = bc_h(l)%i(m)            
@@ -364,5 +375,7 @@
         pt_p(nzt+1,:,:) = pt_p(nzt,:,:)
     ELSEIF ( ibc_pt_t == 2 )  THEN
+        !$ACC KERNELS PRESENT(pt_p, dzu)
         pt_p(nzt+1,:,:) = pt_p(nzt,:,:) + bc_pt_t_val * dzu(nzt+1)
+        !$ACC END KERNELS
     ENDIF
 
@@ -379,4 +392,6 @@
              kb = MERGE( -1, 1, l == 0 )
              !$OMP PARALLEL DO PRIVATE( i, j, k )
+             !$ACC PARALLEL LOOP PRIVATE(i, j, k) &
+             !$ACC PRESENT(bc_h, e_p)
              DO  m = 1, bc_h(l)%ns
                 i = bc_h(l)%i(m)            
@@ -444,5 +459,7 @@
 
        IF ( .NOT. child_domain )  THEN
+          !$ACC KERNELS PRESENT(e_p)
           e_p(nzt+1,:,:) = e_p(nzt,:,:)
+          !$ACC END KERNELS
 !
 !--    Nesting case: if parent operates in RANS mode and child in LES mode,
Index: palm/trunk/SOURCE/buoyancy.f90
===================================================================
--- palm/trunk/SOURCE/buoyancy.f90	(revision 3633)
+++ palm/trunk/SOURCE/buoyancy.f90	(revision 3634)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! OpenACC port for SPEC
+! 
+! 3538 2018-11-20 10:55:41Z suehring
 ! Remove unnecessary double-masking of topography
 ! 
@@ -175,4 +178,8 @@
 !
 !--       Normal case: horizontal surface
+          !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i, j, k) &
+          !$ACC PRESENT(var) &
+          !$ACC PRESENT(ref_state) &
+          !$ACC PRESENT(tend)
           DO  i = nxl, nxr
              DO  j = nys, nyn
Index: palm/trunk/SOURCE/coriolis.f90
===================================================================
--- palm/trunk/SOURCE/coriolis.f90	(revision 3633)
+++ palm/trunk/SOURCE/coriolis.f90	(revision 3634)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! OpenACC port for SPEC
+! 
+! 3538 2018-11-20 10:55:41Z suehring
 ! Note concerning topography masking added
 ! 
@@ -145,4 +148,8 @@
 !--       u-component
           CASE ( 1 )
+             !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i, j, k, flag) &
+             !$ACC PRESENT(wall_flags_0) &
+             !$ACC PRESENT(v, w, vg) &
+             !$ACC PRESENT(tend)
              DO  i = nxlu, nxr
                 DO  j = nys, nyn
@@ -167,4 +174,8 @@
 !--       v-component
           CASE ( 2 )
+             !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i, j, k, flag) &
+             !$ACC PRESENT(wall_flags_0) &
+             !$ACC PRESENT(u, ug) &
+             !$ACC PRESENT(tend)
              DO  i = nxl, nxr
                 DO  j = nysv, nyn
@@ -185,4 +196,8 @@
 !--       w-component
           CASE ( 3 )
+             !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i, j, k, flag) &
+             !$ACC PRESENT(wall_flags_0) &
+             !$ACC PRESENT(u) &
+             !$ACC PRESENT(tend)
              DO  i = nxl, nxr
                 DO  j = nys, nyn
Index: palm/trunk/SOURCE/cuda_fft_interfaces.f90
===================================================================
--- palm/trunk/SOURCE/cuda_fft_interfaces.f90	(revision 3634)
+++ palm/trunk/SOURCE/cuda_fft_interfaces.f90	(revision 3634)
@@ -0,0 +1,160 @@
+!> @file cuda_fft_interfaces.f90
+!--------------------------------------------------------------------------------!
+! This file is part of PALM.
+!
+! PALM is free software: you can redistribute it and/or modify it under the terms
+! of the GNU General Public License as published by the Free Software Foundation,
+! either version 3 of the License, or (at your option) any later version.
+!
+! PALM is distributed in the hope that it will be useful, but WITHOUT ANY
+! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
+! A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
+!
+! You should have received a copy of the GNU General Public License along with
+! PALM. If not, see <http://www.gnu.org/licenses/>.
+!
+! Copyright 1997-2018 Leibniz Universitaet Hannover
+!--------------------------------------------------------------------------------!
+!
+! Current revisions:
+! -----------------
+! 
+! 
+! Former revisions:
+! -----------------
+! $Id$
+! Initial revision ( OpenACC port for SPEC )
+! 
+! 1683 2015-10-07 23:57:51Z knoop
+!
+!
+! Description:
+! ------------
+!> FORTRAN interfaces for the CUDA fft
+!> Routines for the fft along x and y (forward/backward) using the CUDA fft
+!--------------------------------------------------------------------------------!
+ MODULE cuda_fft_interfaces
+ 
+
+#if defined ( __cuda_fft )
+
+    USE kinds
+
+    INTEGER(iwp) ::  CUFFT_FORWARD = -1   !<
+    INTEGER(iwp) ::  CUFFT_INVERSE =  1   !<
+    INTEGER(iwp) ::  CUFFT_R2C = Z'2a'    !< Real to Complex (interleaved)
+    INTEGER(iwp) ::  CUFFT_C2R = Z'2c'    !< Complex (interleaved) to Real
+    INTEGER(iwp) ::  CUFFT_C2C = Z'29'    !< Complex to Complex, interleaved
+    INTEGER(iwp) ::  CUFFT_D2Z = Z'6a'    !< Double to Double-Complex
+    INTEGER(iwp) ::  CUFFT_Z2D = Z'6c'    !< Double-Complex to Double
+    INTEGER(iwp) ::  CUFFT_Z2Z = Z'69'    !< Double-Complex to Double-Complex
+
+    PUBLIC
+
+
+!
+!-- cufftPlan1d( cufftHandle *plan, int nx, cufftType type, int batch )
+    INTERFACE CUFFTPLAN1D
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> @todo Missing subroutine description.
+!------------------------------------------------------------------------------!
+       SUBROUTINE CUFFTPLAN1D( plan, nx, type, batch ) bind( C, name='cufftPlan1d' )
+
+          USE ISO_C_BINDING
+
+          INTEGER(C_INT)        ::  plan   !< 
+          INTEGER(C_INT), value ::  batch  !< 
+          INTEGER(C_INT), value ::  nx     !< 
+          INTEGER(C_INT), value ::  type   !< 
+       END SUBROUTINE CUFFTPLAN1D
+
+    END INTERFACE CUFFTPLAN1D
+
+!
+!-- cufftDestroy( cufftHandle plan )  !!! remove later if not really needed !!!
+    INTERFACE CUFFTDESTROY
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> @todo Missing subroutine description.
+!------------------------------------------------------------------------------!
+       SUBROUTINE CUFFTDESTROY( plan ) bind( C, name='cufftDestroy' )
+
+          USE ISO_C_BINDING
+
+          INTEGER(C_INT), VALUE ::  plan
+
+       END SUBROUTINE CUFFTDESTROY
+
+    END INTERFACE CUFFTDESTROY
+
+
+    INTERFACE CUFFTEXECZ2D
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> @todo Missing subroutine description.
+!------------------------------------------------------------------------------!
+       SUBROUTINE CUFFTEXECZ2D( plan, idata, odata ) bind( C, name='cufftExecZ2D' )
+
+          USE ISO_C_BINDING
+          USE kinds
+
+          INTEGER(C_INT), VALUE ::  plan          !<
+          COMPLEX(dp), DEVICE   ::  idata(:,:,:)  !<
+          REAL(dp), DEVICE      ::  odata(:,:,:)  !<
+
+       END SUBROUTINE CUFFTEXECZ2D
+
+    END INTERFACE CUFFTEXECZ2D
+
+
+    INTERFACE CUFFTEXECD2Z
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> @todo Missing subroutine description.
+!------------------------------------------------------------------------------!
+       SUBROUTINE CUFFTEXECD2Z( plan, idata, odata ) bind( C, name='cufftExecD2Z' )
+
+          USE ISO_C_BINDING
+          
+          USE kinds
+
+          INTEGER(C_INT), VALUE ::  plan          !<
+          REAL(dp), DEVICE      ::  idata(:,:,:)  !<
+          COMPLEX(dp), DEVICE   ::  odata(:,:,:)  !<
+
+       END SUBROUTINE CUFFTEXECD2Z
+
+    END INTERFACE CUFFTEXECD2Z
+
+#else
+
+    INTERFACE CUFFTdummy
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Dummy interface to avoid compiler warnings in case of no bublic objects
+!> declared.
+!------------------------------------------------------------------------------!
+       SUBROUTINE CUFFTdummy( dummy )
+       
+          USE kinds
+
+          REAL(wp) ::  dummy  !<
+
+       END SUBROUTINE CUFFTdummy
+
+    END INTERFACE CUFFTdummy
+
+#endif
+
+ END MODULE cuda_fft_interfaces
Index: palm/trunk/SOURCE/diffusion_s.f90
===================================================================
--- palm/trunk/SOURCE/diffusion_s.f90	(revision 3633)
+++ palm/trunk/SOURCE/diffusion_s.f90	(revision 3634)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! OpenACC port for SPEC
+! 
+! 3547 2018-11-21 13:21:24Z suehring
 ! variables documented
 ! 
@@ -194,4 +197,24 @@
 #endif
 
+       !$ACC PARALLEL LOOP COLLAPSE(2) PRIVATE(i, j, k, m) &
+       !$ACC PRIVATE(surf_e, surf_s, flag, mask_top, mask_bottom) &
+       !$ACC PRIVATE(mask_north, mask_south, mask_west, mask_east) &
+       !$ACC PRESENT(wall_flags_0, kh) &
+       !$ACC PRESENT(s) &
+       !$ACC PRESENT(ddzu, ddzw, drho_air, rho_air_zw) &
+       !$ACC PRESENT(surf_def_h(0:2), surf_def_v(0:3)) &
+       !$ACC PRESENT(surf_lsm_h, surf_lsm_v(0:3)) &
+       !$ACC PRESENT(surf_usm_h, surf_usm_v(0:3)) &
+       !$ACC PRESENT(s_flux_def_h_up, s_flux_def_h_down) &
+       !$ACC PRESENT(s_flux_t) &
+       !$ACC PRESENT(s_flux_def_v_north, s_flux_def_v_south) &
+       !$ACC PRESENT(s_flux_def_v_east, s_flux_def_v_west) &
+       !$ACC PRESENT(s_flux_lsm_h_up) &
+       !$ACC PRESENT(s_flux_lsm_v_north, s_flux_lsm_v_south) &
+       !$ACC PRESENT(s_flux_lsm_v_east, s_flux_lsm_v_west) &
+       !$ACC PRESENT(s_flux_usm_h_up) &
+       !$ACC PRESENT(s_flux_usm_v_north, s_flux_usm_v_south) &
+       !$ACC PRESENT(s_flux_usm_v_east, s_flux_usm_v_west) &
+       !$ACC PRESENT(tend)
        DO  i = nxl, nxr
           DO  j = nys,nyn
Index: palm/trunk/SOURCE/diffusion_u.f90
===================================================================
--- palm/trunk/SOURCE/diffusion_u.f90	(revision 3633)
+++ palm/trunk/SOURCE/diffusion_u.f90	(revision 3634)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! OpenACC port for SPEC
+! 
+! 3547 2018-11-21 13:21:24Z suehring
 ! variables documented
 ! 
@@ -172,4 +175,14 @@
 
 
+       !$ACC PARALLEL LOOP COLLAPSE(2) PRIVATE(i, j, k, l, m) &
+       !$ACC PRIVATE(surf_e, surf_s, flag, kmym, kmyp, kmzm, kmzp) &
+       !$ACC PRIVATE(mask_bottom, mask_north, mask_south, mask_top) &
+       !$ACC PRESENT(wall_flags_0, km) &
+       !$ACC PRESENT(u, v, w) &
+       !$ACC PRESENT(ddzu, ddzw, drho_air, rho_air_zw) &
+       !$ACC PRESENT(surf_def_h(0:2), surf_def_v(0:1)) &
+       !$ACC PRESENT(surf_lsm_h, surf_lsm_v(0:1)) &
+       !$ACC PRESENT(surf_usm_h, surf_usm_v(0:1)) &
+       !$ACC PRESENT(tend)
        DO  i = nxlu, nxr
           DO  j = nys, nyn
Index: palm/trunk/SOURCE/diffusion_v.f90
===================================================================
--- palm/trunk/SOURCE/diffusion_v.f90	(revision 3633)
+++ palm/trunk/SOURCE/diffusion_v.f90	(revision 3634)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! OpenACC port for SPEC
+! 
+! 3547 2018-11-21 13:21:24Z suehring
 ! variables documented
 ! 
@@ -165,4 +168,14 @@
        REAL(wp)     ::  mask_top      !< flag to mask vertical downward-facing surface      
 
+       !$ACC PARALLEL LOOP COLLAPSE(2) PRIVATE(i, j, k, l, m) &
+       !$ACC PRIVATE(surf_e, surf_s, flag, kmxm, kmxp, kmzm, kmzp) &
+       !$ACC PRIVATE(mask_bottom, mask_east, mask_west, mask_top) &
+       !$ACC PRESENT(wall_flags_0, km) &
+       !$ACC PRESENT(u, v, w) &
+       !$ACC PRESENT(ddzu, ddzw, drho_air, rho_air_zw) &
+       !$ACC PRESENT(surf_def_h(0:2), surf_def_v(2:3)) &
+       !$ACC PRESENT(surf_lsm_h, surf_lsm_v(2:3)) &
+       !$ACC PRESENT(surf_usm_h, surf_usm_v(0:3)) &
+       !$ACC PRESENT(tend)
        DO  i = nxl, nxr
           DO  j = nysv, nyn
Index: palm/trunk/SOURCE/diffusion_w.f90
===================================================================
--- palm/trunk/SOURCE/diffusion_w.f90	(revision 3633)
+++ palm/trunk/SOURCE/diffusion_w.f90	(revision 3634)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! OpenACC port for SPEC
+! 
+! 3547 2018-11-21 13:21:24Z suehring
 ! variables documented
 ! 
@@ -166,4 +169,14 @@
 
 
+       !$ACC PARALLEL LOOP COLLAPSE(2) PRIVATE(i, j, k, l, m) &
+       !$ACC PRIVATE(surf_e, surf_s, flag, kmxm, kmxp, kmym, kmyp) &
+       !$ACC PRIVATE(mask_west, mask_east, mask_south, mask_north) &
+       !$ACC PRESENT(wall_flags_0, km) &
+       !$ACC PRESENT(u, v, w) &
+       !$ACC PRESENT(ddzu, ddzw, rho_air, drho_air_zw) &
+       !$ACC PRESENT(surf_def_v(0:3)) &
+       !$ACC PRESENT(surf_lsm_v(0:3)) &
+       !$ACC PRESENT(surf_usm_v(0:3)) &
+       !$ACC PRESENT(tend)
        DO  i = nxl, nxr
           DO  j = nys, nyn
Index: palm/trunk/SOURCE/exchange_horiz.f90
===================================================================
--- palm/trunk/SOURCE/exchange_horiz.f90	(revision 3633)
+++ palm/trunk/SOURCE/exchange_horiz.f90	(revision 3634)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! OpenACC port for SPEC
+! 
+! 3241 2018-09-12 15:02:00Z raasch
 ! unused variables removed
 ! 
@@ -117,4 +120,7 @@
 
 
+#ifdef _OPENACC
+    INTEGER(iwp) ::  i           !<
+#endif
     INTEGER(iwp) ::  nbgp_local  !<
     
@@ -124,4 +130,15 @@
 
     CALL cpu_log( log_point_s(2), 'exchange_horiz', 'start' )
+
+#ifdef _OPENACC
+    !$ACC UPDATE IF_PRESENT &
+    !$ACC HOST(ar(:,:,nxr-nbgp_local+1:nxr)) &
+    !$ACC HOST(ar(:,:,nxl:nxl+nbgp_local-1))
+    DO i = nxl-nbgp_local, nxr+nbgp_local
+       !$ACC UPDATE IF_PRESENT &
+       !$ACC HOST(ar(:,nyn-nbgp_local+1:nyn,i)) &
+       !$ACC HOST(ar(:,nys:nys+nbgp_local-1,i))
+    ENDDO
+#endif
 
 #if defined( __parallel )
@@ -263,4 +280,16 @@
 
 #endif
+
+#ifdef _OPENACC
+    !$ACC UPDATE IF_PRESENT &
+    !$ACC DEVICE(ar(:,:,nxl-nbgp_local:nxl-1)) &
+    !$ACC DEVICE(ar(:,:,nxr+1:nxr+nbgp_local))
+    DO i = nxl-nbgp_local, nxr+nbgp_local
+       !$ACC UPDATE IF_PRESENT &
+       !$ACC DEVICE(ar(:,nys-nbgp_local:nys-1,i)) &
+       !$ACC DEVICE(ar(:,nyn+1:nyn+nbgp_local,i))
+    ENDDO
+#endif
+
     CALL cpu_log( log_point_s(2), 'exchange_horiz', 'stop' )
 
Index: palm/trunk/SOURCE/fft_xy_mod.f90
===================================================================
--- palm/trunk/SOURCE/fft_xy_mod.f90	(revision 3633)
+++ palm/trunk/SOURCE/fft_xy_mod.f90	(revision 3634)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! OpenACC port for SPEC
+! 
+! 3241 2018-09-12 15:02:00Z raasch
 ! preprocessor switches for variables that are required on NEC only
 ! 
@@ -156,8 +159,12 @@
         ONLY:  fft_method, message_string
         
+    USE cuda_fft_interfaces
+        
     USE indices,                                                               &
         ONLY:  nx, ny, nz
         
-#if defined( __fftw )
+#if defined( __cuda_fft )
+    USE ISO_C_BINDING
+#elif defined( __fftw )
     USE, INTRINSIC ::  ISO_C_BINDING
 #endif
@@ -210,4 +217,10 @@
     REAL(wp), DIMENSION(:), ALLOCATABLE, SAVE ::  trig_yf  !<
     
+#elif defined( __cuda_fft )
+    INTEGER(C_INT), SAVE ::  plan_xf  !<
+    INTEGER(C_INT), SAVE ::  plan_xi  !<
+    INTEGER(C_INT), SAVE ::  plan_yf  !<
+    INTEGER(C_INT), SAVE ::  plan_yi  !<
+
 #endif
 
@@ -298,4 +311,8 @@
        ENDIF
 
+#if defined( _OPENACC ) && defined( __cuda_fft )
+       fft_method = 'system-specific'
+#endif
+
        IF ( fft_method == 'system-specific' )  THEN
 
@@ -346,4 +363,9 @@
           CALL ZDFFTM( 0, ny+1, nz1, sqr_dny, work_y, ny+4, work_y, ny+4,      &
                        trig_yb, worky, 0 )
+#elif defined( __cuda_fft )
+          CALL CUFFTPLAN1D( plan_xf, nx+1, CUFFT_D2Z, (nyn_x-nys_x+1) * (nzt_x-nzb_x+1) )
+          CALL CUFFTPLAN1D( plan_xi, nx+1, CUFFT_Z2D, (nyn_x-nys_x+1) * (nzt_x-nzb_x+1) )
+          CALL CUFFTPLAN1D( plan_yf, ny+1, CUFFT_D2Z, (nxr_y-nxl_y+1) * (nzt_y-nzb_y+1) )
+          CALL CUFFTPLAN1D( plan_yi, ny+1, CUFFT_Z2D, (nxr_y-nxl_y+1) * (nzt_y-nzb_y+1) )
 #else
           message_string = 'no system-specific fft-call available'
@@ -425,4 +447,8 @@
 #elif defined( __nec )
        REAL(wp), DIMENSION(6*(nx+1)) ::  work2  !<
+#elif defined( __cuda_fft )
+       COMPLEX(dp), DIMENSION(0:(nx+1)/2,nys_x:nyn_x,nzb_x:nzt_x) ::           &
+          ar_tmp  !<
+       !$ACC DECLARE CREATE(ar_tmp)
 #endif
 
@@ -726,4 +752,53 @@
              ENDDO
              !$OMP END PARALLEL
+
+          ENDIF
+
+#elif defined( __cuda_fft )
+
+          IF ( forward_fft )  THEN
+
+             !$ACC HOST_DATA USE_DEVICE(ar, ar_tmp)
+             CALL CUFFTEXECD2Z( plan_xf, ar, ar_tmp )
+             !$ACC END HOST_DATA
+
+             !$ACC PARALLEL LOOP COLLAPSE(2) PRIVATE(i,j,k) &
+             !$ACC PRESENT(ar, ar_tmp)
+             DO  k = nzb_x, nzt_x
+                DO  j = nys_x, nyn_x
+
+                   DO  i = 0, (nx+1)/2
+                      ar(i,j,k)      = REAL( ar_tmp(i,j,k), KIND=wp )  * dnx
+                   ENDDO
+
+                   DO  i = 1, (nx+1)/2 - 1
+                      ar(nx+1-i,j,k) = AIMAG( ar_tmp(i,j,k) ) * dnx
+                   ENDDO
+
+                ENDDO
+             ENDDO
+
+          ELSE
+
+             !$ACC PARALLEL LOOP COLLAPSE(2) PRIVATE(i,j,k) &
+             !$ACC PRESENT(ar, ar_tmp)
+             DO  k = nzb_x, nzt_x
+                DO  j = nys_x, nyn_x
+
+                   ar_tmp(0,j,k) = CMPLX( ar(0,j,k), 0.0_wp, KIND=wp )
+
+                   DO  i = 1, (nx+1)/2 - 1
+                      ar_tmp(i,j,k) = CMPLX( ar(i,j,k), ar(nx+1-i,j,k),        &
+                                             KIND=wp )
+                   ENDDO
+                   ar_tmp((nx+1)/2,j,k) = CMPLX( ar((nx+1)/2,j,k), 0.0_wp,     &
+                                                 KIND=wp )
+
+                ENDDO
+             ENDDO
+
+             !$ACC HOST_DATA USE_DEVICE(ar, ar_tmp)
+             CALL CUFFTEXECZ2D( plan_xi, ar_tmp, ar )
+             !$ACC END HOST_DATA
 
           ENDIF
@@ -1001,4 +1076,8 @@
 #elif defined( __nec )
        REAL(wp), DIMENSION(6*(ny+1)) ::  work2  !<
+#elif defined( __cuda_fft )
+       COMPLEX(dp), DIMENSION(0:(ny+1)/2,nxl_y:nxr_y,nzb_y:nzt_y) ::           &
+          ar_tmp  !<
+       !$ACC DECLARE CREATE(ar_tmp)
 #endif
 
@@ -1278,4 +1357,53 @@
 
           ENDIF
+#elif defined( __cuda_fft )
+
+          IF ( forward_fft )  THEN
+
+             !$ACC HOST_DATA USE_DEVICE(ar, ar_tmp)
+             CALL CUFFTEXECD2Z( plan_yf, ar, ar_tmp )
+             !$ACC END HOST_DATA
+
+             !$ACC PARALLEL LOOP COLLAPSE(2) PRIVATE(i,j,k) &
+             !$ACC PRESENT(ar, ar_tmp)
+             DO  k = nzb_y, nzt_y
+                DO  i = nxl_y, nxr_y
+
+                   DO  j = 0, (ny+1)/2
+                      ar(j,i,k)      = REAL( ar_tmp(j,i,k), KIND=wp )  * dny
+                   ENDDO
+
+                   DO  j = 1, (ny+1)/2 - 1
+                      ar(ny+1-j,i,k) = AIMAG( ar_tmp(j,i,k) ) * dny
+                   ENDDO
+
+                ENDDO
+             ENDDO
+
+          ELSE
+
+             !$ACC PARALLEL LOOP COLLAPSE(2) PRIVATE(i,j,k) &
+             !$ACC PRESENT(ar, ar_tmp)
+             DO  k = nzb_y, nzt_y
+                DO  i = nxl_y, nxr_y
+
+                   ar_tmp(0,i,k) = CMPLX( ar(0,i,k), 0.0_wp, KIND=wp )
+
+                   DO  j = 1, (ny+1)/2 - 1
+                      ar_tmp(j,i,k) = CMPLX( ar(j,i,k), ar(ny+1-j,i,k),        &
+                                             KIND=wp )
+                   ENDDO
+                   ar_tmp((ny+1)/2,i,k) = CMPLX( ar((ny+1)/2,i,k), 0.0_wp,     &
+                                                 KIND=wp )
+
+                ENDDO
+             ENDDO
+
+             !$ACC HOST_DATA USE_DEVICE(ar, ar_tmp)
+             CALL CUFFTEXECZ2D( plan_yi, ar_tmp, ar )
+             !$ACC END HOST_DATA
+
+          ENDIF
+
 #endif
 
Index: palm/trunk/SOURCE/poisfft_mod.f90
===================================================================
--- palm/trunk/SOURCE/poisfft_mod.f90	(revision 3633)
+++ palm/trunk/SOURCE/poisfft_mod.f90	(revision 3634)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! OpenACC port for SPEC
+! 
+! 3241 2018-09-12 15:02:00Z raasch
 ! unused variables removed,
 ! declarations of omp_get_thread_num now as omp-directive
@@ -250,4 +253,5 @@
        REAL(wp), DIMENSION(1:nz,nys:nyn,nxl:nxr) ::  ar      !<
        REAL(wp), DIMENSION(nys:nyn,nxl:nxr,1:nz) ::  ar_inv  !<
+       !$ACC DECLARE CREATE(ar_inv)
 
        REAL(wp), DIMENSION(:,:,:),   ALLOCATABLE ::  ar1      !<
@@ -262,4 +266,5 @@
        IF ( .NOT. poisfft_initialized )  CALL poisfft_init
 
+#ifndef _OPENACC
 !
 !--    Two-dimensional Fourier Transformation in x- and y-direction.
@@ -295,4 +300,5 @@
 
        ELSEIF ( .NOT. transpose_compute_overlap )  THEN
+#endif
 
 !
@@ -366,4 +372,5 @@
           CALL cpu_log( log_point_s(8), 'transpo invers', 'stop' )
 
+#ifndef _OPENACC
        ELSE
 
@@ -698,4 +705,5 @@
 
        ENDIF
+#endif
 
        CALL cpu_log( log_point_s(3), 'poisfft', 'stop' )
Index: palm/trunk/SOURCE/pres.f90
===================================================================
--- palm/trunk/SOURCE/pres.f90	(revision 3633)
+++ palm/trunk/SOURCE/pres.f90	(revision 3634)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! OpenACC port for SPEC
+! 
+! 3347 2018-10-15 14:21:08Z suehring
 ! Bugfixes in offline nesting.
 ! Add comment. 
@@ -232,4 +235,17 @@
 
     CALL cpu_log( log_point(8), 'pres', 'start' )
+
+!$ACC DATA COPYOUT(d, tend) &
+!$ACC COPY(u, v, w, p) &
+!$ACC COPYIN(rho_air, rho_air_zw, ddzu, ddzw, wall_flags_0)
+
+!$ACC DATA &
+!$ACC COPYIN(bc_h(0:1)) &
+!$ACC COPYIN(bc_h(0)%i(1:bc_h(0)%ns)) &
+!$ACC COPYIN(bc_h(0)%j(1:bc_h(0)%ns)) &
+!$ACC COPYIN(bc_h(0)%k(1:bc_h(0)%ns)) &
+!$ACC COPYIN(bc_h(1)%i(1:bc_h(1)%ns)) &
+!$ACC COPYIN(bc_h(1)%j(1:bc_h(1)%ns)) &
+!$ACC COPYIN(bc_h(1)%k(1:bc_h(1)%ns))
 
 
@@ -442,4 +458,6 @@
     ELSE
        !$OMP PARALLEL DO SCHEDULE( STATIC ) PRIVATE (i,j,k)
+       !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i, j, k) &
+       !$ACC PRESENT(d)
        DO  i = nxl, nxr
           DO  j = nys, nyn
@@ -490,4 +508,7 @@
     !$OMP PARALLEL PRIVATE (i,j,k)
     !$OMP DO SCHEDULE( STATIC )
+    !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i, j, k) &
+    !$ACC PRESENT(u, v, w, rho_air, rho_air_zw, ddzw, wall_flags_0) &
+    !$ACC PRESENT(d)
     DO  i = nxl, nxr
        DO  j = nys, nyn
@@ -513,4 +534,7 @@
        !$OMP PARALLEL PRIVATE (i,j,k) FIRSTPRIVATE(threadsum) REDUCTION(+:localsum)
        !$OMP DO SCHEDULE( STATIC )
+       !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i,j,k) &
+       !$ACC REDUCTION(+:threadsum) COPY(threadsum) &
+       !$ACC PRESENT(d)
        DO  i = nxl, nxr
           DO  j = nys, nyn
@@ -547,4 +571,6 @@
 !--    z-direction
        !$OMP PARALLEL DO PRIVATE (i,j,k)
+       !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i, j, k) &
+       !$ACC PRESENT(d, tend)
        DO  i = nxl, nxr
           DO  j = nys, nyn
@@ -565,4 +591,6 @@
 !--       Upward facing
           !$OMP PARALLEL DO PRIVATE( i, j, k )
+          !$ACC PARALLEL LOOP PRIVATE(i, j, k) &
+          !$ACC PRESENT(bc_h, tend)
           DO  m = 1, bc_h(0)%ns
              i = bc_h(0)%i(m)
@@ -574,4 +602,6 @@
 !--       Downward facing
           !$OMP PARALLEL DO PRIVATE( i, j, k )
+          !$ACC PARALLEL LOOP PRIVATE(i, j, k) &
+          !$ACC PRESENT(bc_h, tend)
           DO  m = 1, bc_h(1)%ns
              i = bc_h(1)%i(m)
@@ -621,4 +651,6 @@
 !--       Dirichlet
           !$OMP PARALLEL DO PRIVATE (i,j,k)
+          !$ACC PARALLEL LOOP COLLAPSE(2) PRIVATE(i, j) &
+          !$ACC PRESENT(tend)
           DO  i = nxlg, nxrg
              DO  j = nysg, nyng
@@ -688,4 +720,6 @@
        !$OMP PARALLEL PRIVATE (i,j,k)
        !$OMP DO
+       !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i, j, k) &
+       !$ACC PRESENT(p, tend)
        DO  i = nxl-1, nxr+1
           DO  j = nys-1, nyn+1
@@ -701,4 +735,6 @@
        !$OMP PARALLEL PRIVATE (i,j,k)
        !$OMP DO
+       !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i, j, k) &
+       !$ACC PRESENT(p, tend)
        DO  i = nxl-1, nxr+1
           DO  j = nys-1, nyn+1
@@ -733,4 +769,6 @@
     !$OMP PARALLEL PRIVATE (i,j,k)
     !$OMP DO
+    !$ACC PARALLEL LOOP COLLAPSE(2) PRIVATE(i, j, k) &
+    !$ACC PRESENT(u, v, w, tend, ddzu, wall_flags_0)
     DO  i = nxl, nxr   
        DO  j = nys, nyn
@@ -900,4 +938,7 @@
 #else
        !$OMP DO SCHEDULE( STATIC )
+       !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i, j, k) &
+       !$ACC PRESENT(u, v, w, rho_air, rho_air_zw, ddzw, wall_flags_0) &
+       !$ACC PRESENT(d)
        DO  i = nxl, nxr
           DO  j = nys, nyn
@@ -916,4 +957,7 @@
 !--    Compute possible PE-sum of divergences for flow_statistics
        !$OMP DO SCHEDULE( STATIC )
+       !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i, j, k) &
+       !$ACC REDUCTION(+:threadsum) COPY(threadsum) &
+       !$ACC PRESENT(d)
        DO  i = nxl, nxr
           DO  j = nys, nyn
@@ -939,4 +983,6 @@
     CALL cpu_log( log_point(8), 'pres', 'stop' )
 
+!$ACC END DATA
+!$ACC END DATA
 
  END SUBROUTINE pres
